
#ifdef TWO_MODULE_BANK
 #define MEM_SIZE			0x20000000    //512M bytes
#else
 #define MEM_SIZE			0x08000000    //128M bytes
#endif
#define SMM_SIZE			( 256 * 1024 )
#define SMM_OFFSET			0x40400000

#define SB_PORT				2
#define CHIPSET_DEV_NUM	 		0xF
#define IDSEL_BASE			11	//device 1
#define SMBUS_BASE			0x6000
#define GPIO_BASE			0x6100
#define MFGPT_BASE			0x6200
#define PMLogic_BASE			0x9d00
#define ACPI_BASE			0x9c00


#define CPU_REV_1_0			0x11
#define CPU_REV_1_1			0x12
#define CPU_REV_1_2			0x13
#define CPU_REV_1_3			0x14
#define CPU_REV_2_0			0x20
#define CPU_REV_2_1			0x21
#define CPU_REV_2_2			0x22
#define CPU_REV_3_0			0x30



#define CPU_XC_CONFIG			0x1210
#define CPU_BC_CONF_0			0x1900
#define CPU_PF_BTB_CONF			0x1100
#define CPU_RCONF_BYPASS		0x180A
#define CPU_GLD_MSR_CONFIG		0x2001
#define CPU_RCONF_DEFAULT		0x1808
#define CPU_RCONF_C0_DF			0x180C
#define CPU_RCONF_E0_FF			0x180D


#define XC_CONFIG_SUSP_ON_HLT		( 1 << 0 )
#define TSC_SUSP_SET			( 1 << 5 )
#define SUSP_EN_SET			( 1 << 12 )
#define BTB_ENABLE_SET			( 1 << 0 )
#define RETURN_STACK_ENABLE_SET		( 1 << 4 )



#define GPIOH_OUT_AUX1_SELECT		( GPIO_BASE + 0x90 )
#define GPIOH_OUTPUT_ENABLE		( GPIO_BASE + 0x84 )
#define GPIO_03_FILER_AMOUNT		( GPIO_BASE + 0x68 )
#define GPIO_06_FILTER_AMOUNT		( GPIO_BASE + 0xD0 )
#define GPIO_FE_SELECT_6		( GPIO_BASE + 0xF6 )
#define GPIOL_OUT_AUX1_SELECT		( GPIO_BASE + 0x10 )
#define GPIOL_OUTPUT_ENABLE		( GPIO_BASE + 0x04 )
#define GPIOL_IN_AUX1_SELECT		( GPIO_BASE + 0x34 )
#define GPIOL_INPUT_ENABLE		( GPIO_BASE + 0x20 )


#define GPIOH_24_SET			( 1 << 8 )
#define GPIOL_14_SET			( 1 << 14 )
#define GPIOL_15_SET			( 1 << 15 )
#define GPIOL_8_SET			( 1 << 8 )
#define GPIOL_9_SET			( 1 << 9 )
#define GPIOL_4_SET			( 1 << 4 )
#define GPIOL_3_SET			( 1 << 3 )


#define LBAR_EN				1
#define	IO_MASK				0x1f

//SMBUS
#define SMBUS_SMBCTL2			( SMBUS_BASE + 0x05 )
#define SMBUS_SMBCST			( SMBUS_BASE + 0x02 )
#define SMBUS_SMBADDR			( SMBUS_BASE + 0x04 )


#define SMBCTL2_ENABLE_SET		( 1 << 0 )
#define SMBCST_TSDA_SET			( 1 << 4 )
#define SMBADDR_SAEN_SET		( 1 << 7 )


#define GL1_PCI				4
#define GL1_GLCP			3
#define GL1_FG				5
#define GL0_GLIU0			0
#define GL0_GLIU1			2
#define GL0_MC				1
#define GL0_DF				6
#define GL0_VG				4
#define GL0_GP				5

#define SB_PORT				2
#define SB_SHIFT			20

#define MSR_GLIU0			(( GL0_GLIU0 << 29 ) + ( 1 << 28 ))
#define MSR_GLIU1			( GL0_GLIU1 << 29 )
#define MSR_PCI				(( GL1_PCI << 26 ) + MSR_GLIU1 )
#define MSR_GLCP			(( GL1_GLCP << 26 ) + MSR_GLIU1 )
#define MSR_FG				(( GL1_FG << 26 ) + MSR_GLIU1 )
#define MSR_MC				( GL0_MC << 29 )
#define MSR_DF				( GL0_DF << 29 )
#define MSR_VG				( GL0_VG << 29 )
#define MSR_GP				( GL0_GP << 29 )

#define MSR_GLIU0_BASE1			( MSR_GLIU0 + 0x20 )
#define MSR_GLIU0_BASE2			( MSR_GLIU0 + 0x21 )
#define MSR_GLIU0_SYSMEM		( MSR_GLIU0 + 0x28 )
#define MSR_GLIU0_SMM			( MSR_GLIU0 + 0x26 )
#define GLIU0_GLD_MSR_COH		( MSR_GLIU0 + 0x80 )
#define MSR_GLIU1_BASE1			( MSR_GLIU1 + 0x20 )
#define MSR_GLIU1_BASE2			( MSR_GLIU1 + 0x21 )
#define MSR_GLIU1_SYSMEM		( MSR_GLIU1 + 0x29 )
#define MSR_GLIU1_SMM			( MSR_GLIU1 + 0x23 )
#define GLIU1_GLD_MSR_COH		( MSR_GLIU1 + 0x80 )
#define MSR_GLIU1_FPU_TRAP		( MSR_GLIU1 + 0xE3 )
#define DF_GLD_MSR_MASTER_CONF		( MSR_DF + 0x2001 )
#define VG_GLD_MSR_CONFIG		( MSR_VG + 0x2001 )
#define GP_GLD_MSR_CONFIG		( MSR_GP + 0x2001 )
#define GLPCI_GLD_MSR_CONFIG		( MSR_PCI + 0x2001 )
#define GLCP_GLD_MSR_CONF		( MSR_GLCP + 0x2001 )
#define GLPCI_REN			( MSR_PCI + 0x2014 )

#define GL_END				0xff

#define MSR_SB				(( SB_PORT << 23 ) + MSR_PCI )

#define MSR_SB_MDD			(( 4 << SB_SHIFT ) + MSR_SB )
#define MSR_SB_GLPCI			MSR_SB

#define	GLPCI_ExtMSR			( MSR_PCI + 0x201E )
#define GLCP_SYS_RSTPLL			( MSR_GLCP + 0x14 )
#define GLCP_DOTPLL			( MSR_GLCP + 0x15 )
#define GLCP_DELAY_CONTROLS		( MSR_GLCP + 0x0F )


#define RSTPLL_LOWER_BOOTSTRAP_SHIFT	4
#define RSTPLL_LOWER_SWFLAGS_SHIFT	26
#define RSTPLL_LOWER_SDRMODE_SHIFT	10
#define RSTPLL_LOWER_BYPASS_SHIFT	15
#define RSTPLL_LOWER_HOLD_COUNT_SHIFT	16


#define RSTPLL_LOWER_CPU_SEMI_SYNC_SET	( 1 << 9 )
#define RSTPLL_LOWER_BYPASS_SET		( 1 << 15 )
#define RSTPLL_LOWER_PCI_SEMI_SYNC_SET	( 1 << 8 )
#define RSTPLL_LOWER_PLL_RESET_SET	( 1 << 13 )
#define RSTPLL_LOWER_PD_SET		( 1 << 14 )
#define RSTPLL_LOWER_CHIP_RESET_SET	( 1 << 0 )

#define DOTPLL_LOWER_PD_SET		( 1 << 14 )


#define MC_CF07_DATA			( MSR_MC + 0x18 )
#define MC_CF8F_DATA			( MSR_MC + 0x19 )
#define MC_CF_RDSYNC			( MSR_MC + 0x1F )
#define MC_CF1017_DATA			( MSR_MC + 0x1A )
#define MC_CFCLK_DBUG			( MSR_MC + 0x1D )



#define CF07_UPPER_D0_CB_SHIFT		4
#define CF07_UPPER_D0_SZ_SHIFT		12
#define CF07_UPPER_D0_PSZ_SHIFT		0
#define CF07_UPPER_D0_MB_SHIFT		8
#define CF07_UPPER_D1_MB_SHIFT		24
#define CF07_UPPER_D1_CB_SHIFT		20
#define CF07_UPPER_D1_SZ_SHIFT		28
#define CF07_UPPER_D1_PSZ_SHIFT		16
#define CF07_LOWER_REF_INT_SHIFT	8
#define CF8F_UPPER_REG_DIMM_SHIFT	4
#define CF8F_LOWER_CAS_LAT_SHIFT	28
#define CF8F_LOWER_ACT2PRE_SHIFT	20
#define CF8F_LOWER_PRE2ACT_SHIFT	16
#define CF8F_LOWER_ACT2CMD_SHIFT	12
#define CF8F_LOWER_ACT2ACT_SHIFT	8
#define CF8F_LOWER_REF2ACT_SHIFT	24

#define CFCLK_LOWER_MASK_CKE_SET0	( 1 << 8 )
#define CFCLK_LOWER_MASK_CKE_SET1	( 1 << 9 )
#define CF07_LOWER_REF_TEST_SET		( 1 << 3 )
#define CF07_LOWER_PROG_DRAM_SET	( 1 << 0 )
#define CF07_LOWER_LOAD_MODE_DDR_SET	( 1 << 28 )
#define CF07_LOWER_LOAD_MODE_DLL_RESET	( 1 << 27 )
#define CF1017_LOWER_PM1_UP_DLY_SET	( 1 << 8 )


#define MDD_UART1_CONF			( MSR_SB_MDD + 0x3A )
#define MDD_UART2_CONF			( MSR_SB_MDD + 0x3E )
#define MDD_RTC_CENTURY_OFFSET		( MSR_SB_MDD + 0x57 )
#define MDD_LBAR_SMB			( MSR_SB_MDD + 0x0B )
#define MDD_LBAR_GPIO			( MSR_SB_MDD + 0x0C )
#define MDD_LBAR_MFGPT			( MSR_SB_MDD + 0x0D )
#define MDD_LBAR_PMS			( MSR_SB_MDD + 0x0F )
#define MDD_LBAR_ACPI			( MSR_SB_MDD + 0x0E )
#define MDD_LEG_IO			( MSR_SB_MDD + 0x14 )
#define MDD_IRQM_YHIGH			( MSR_SB_MDD + 0x21 )



#define ERROR_NO_DIMMS			0x77
#define PORT61H				0x61
#define REF_BIT				0x10

#define CR0_CD				0x40000000
#define CR0_NW				0x20000000
//MC
#define VSM_SIGNATURE		0x204D5356   //"VSM "
#define	VSM_SYS_MGR		0x0
#define ERR_NO_SYS_MGR		(1 << 1)

#define MSR_SMM_LOC		0x133B
#define MSR_SMM_HDR		0x132B
#define MSR_SMM_CTRL		0x1301
#define MSR_RCONF_SMM		0x180E
#define MSR_RCONF_DEFAULT	0x1808

#define INTL_SMI_EN 		( 1 << 4 )
#define EXTL_SMI_EN		( 1 << 5 )
#define SMM_INST_EN		( 1 << 3 )
#define NEST_SMI_EN		( 1 << 2 )
#define SMM_CONTROL		( INTL_SMI_EN + EXTL_SMI_EN + SMM_INST_EN + NEST_SMI_EN )

#define SW_SMI			0xD0
#define CODE_ATTR		0x9B
#define DATA_ATTR		0x93
#define END_MSG_QUEUE		( 10 * 28 )
#define PM_FUNCTION		0x0100
#define AUDIO_FUNCTION		0x0300
#define VSM_EFLAGS		0x00000002
#define VSM_CR0			0x00000014
#define VSM_DR7			0x00000400
#define VSM_STACK_SIZE		0x300
#define SYS_BIOS_INIT		0x00F0

#define SMI_FLAGS_CS_WRITABLE   0x0001		// "Cw" bit  CS is writable
#define SMI_FLAGS_NESTED        0x0100		// "N" bit   Nested SMI
#define SMI_FLAGS_CS_READABLE   0x8000		// "Cr" bit  CS is writable

#define VSM_FLAGS		(SMI_FLAGS_CS_WRITABLE + SMI_FLAGS_NESTED + SMI_FLAGS_CS_READABLE)

#define FG_A20M			0x0011
#define A20M			( 1 << 0 )
#define SPECIAL_LOC		0x800
#define EXTRA_SAVE		4
#define VSM_STACK_FRAME		( 8 * 4 + EXTRA_SAVE )


#define REGION_WP		( 1 << 2 )
#define DEVICE_ID_GX2		0x0028
#define DEVICE_ID_GX3		0x0039
#define DEVICE_ID_5535		0x002B
 
